diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/mgt-headers.h ns-3.41/src/wifi/model/mgt-headers.h
--- ns-3.40/src/wifi/model/mgt-headers.h	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/mgt-headers.h	2024-02-09 14:44:08.589794900 -0800
@@ -46,13 +46,9 @@
 #include "ns3/vht-capabilities.h"
 #include "ns3/vht-operation.h"
 
-#include <list>
-
 namespace ns3
 {
 
-class Packet;
-
 /**
  * Indicate which Information Elements cannot be included in a Per-STA Profile subelement of
  * a Basic Multi-Link Element (see Sec. 35.3.3.4 of 802.11be D3.1):
@@ -524,646 +520,6 @@
     static TypeId GetTypeId();
 };
 
-/****************************
- *     Action frames
- *****************************/
-
-/**
- * \ingroup wifi
- *
- * See IEEE 802.11 chapter 7.3.1.11
- * Header format: | category: 1 | action value: 1 |
- *
- */
-class WifiActionHeader : public Header
-{
-  public:
-    WifiActionHeader();
-    ~WifiActionHeader() override;
-
-    /*
-     * Compatible with table 8-38 IEEE 802.11, Part11, (Year 2012)
-     * Category values - see 802.11-2012 Table 8-38
-     */
-
-    /// CategoryValue enumeration
-    enum CategoryValue // table 9-51 of IEEE 802.11-2020
-    {
-        QOS = 1,
-        BLOCK_ACK = 3,
-        PUBLIC = 4,
-        RADIO_MEASUREMENT = 5, // Category: Radio Measurement
-        MESH = 13,             // Category: Mesh
-        MULTIHOP = 14,         // not used so far
-        SELF_PROTECTED = 15,   // Category: Self Protected
-        DMG = 16,              // Category: DMG
-        FST = 18,              // Category: Fast Session Transfer
-        UNPROTECTED_DMG = 20,  // Category: Unprotected DMG
-        PROTECTED_EHT = 37,    // Category: Protected EHT
-        // Since vendor specific action has no stationary Action value,the parse process is not
-        // here. Refer to vendor-specific-action in wave module.
-        VENDOR_SPECIFIC_ACTION = 127,
-    };
-
-    /// QosActionValue enumeration
-    enum QosActionValue
-    {
-        ADDTS_REQUEST = 0,
-        ADDTS_RESPONSE = 1,
-        DELTS = 2,
-        SCHEDULE = 3,
-        QOS_MAP_CONFIGURE = 4,
-    };
-
-    /**
-     * Block Ack Action field values
-     * See 802.11 Table 8-202
-     */
-    enum BlockAckActionValue
-    {
-        BLOCK_ACK_ADDBA_REQUEST = 0,
-        BLOCK_ACK_ADDBA_RESPONSE = 1,
-        BLOCK_ACK_DELBA = 2
-    };
-
-    /// PublicActionValue enumeration
-    enum PublicActionValue
-    {
-        QAB_REQUEST = 16,
-        QAB_RESPONSE = 17,
-    };
-
-    /// RadioMeasurementActionValue enumeration
-    enum RadioMeasurementActionValue
-    {
-        RADIO_MEASUREMENT_REQUEST = 0,
-        RADIO_MEASUREMENT_REPORT = 1,
-        LINK_MEASUREMENT_REQUEST = 2,
-        LINK_MEASUREMENT_REPORT = 3,
-        NEIGHBOR_REPORT_REQUEST = 4,
-        NEIGHBOR_REPORT_RESPONSE = 5
-    };
-
-    /// MeshActionValue enumeration
-    enum MeshActionValue
-    {
-        LINK_METRIC_REPORT = 0,              // Action Value:0 in Category 13: Mesh
-        PATH_SELECTION = 1,                  // Action Value:1 in Category 13: Mesh
-        PORTAL_ANNOUNCEMENT = 2,             // Action Value:2 in Category 13: Mesh
-        CONGESTION_CONTROL_NOTIFICATION = 3, // Action Value:3 in Category 13: Mesh
-        MDA_SETUP_REQUEST =
-            4, // Action Value:4 in Category 13: Mesh MCCA-Setup-Request (not used so far)
-        MDA_SETUP_REPLY =
-            5, // Action Value:5 in Category 13: Mesh MCCA-Setup-Reply (not used so far)
-        MDAOP_ADVERTISEMENT_REQUEST =
-            6, // Action Value:6 in Category 13: Mesh MCCA-Advertisement-Request (not used so far)
-        MDAOP_ADVERTISEMENTS = 7,      // Action Value:7 in Category 13: Mesh (not used so far)
-        MDAOP_SET_TEARDOWN = 8,        // Action Value:8 in Category 13: Mesh (not used so far)
-        TBTT_ADJUSTMENT_REQUEST = 9,   // Action Value:9 in Category 13: Mesh (not used so far)
-        TBTT_ADJUSTMENT_RESPONSE = 10, // Action Value:10 in Category 13: Mesh (not used so far)
-    };
-
-    /// MultihopActionValue enumeration
-    enum MultihopActionValue
-    {
-        PROXY_UPDATE = 0,              // not used so far
-        PROXY_UPDATE_CONFIRMATION = 1, // not used so far
-    };
-
-    /// SelfProtectedActionValue enumeration
-    enum SelfProtectedActionValue // Category: 15 (Self Protected)
-    {
-        PEER_LINK_OPEN = 1,    // Mesh Peering Open
-        PEER_LINK_CONFIRM = 2, // Mesh Peering Confirm
-        PEER_LINK_CLOSE = 3,   // Mesh Peering Close
-        GROUP_KEY_INFORM = 4,  // Mesh Group Key Inform
-        GROUP_KEY_ACK = 5,     // Mesh Group Key Acknowledge
-    };
-
-    /**
-     * DMG Action field values
-     * See 802.11ad Table 8-281b
-     */
-    enum DmgActionValue
-    {
-        DMG_POWER_SAVE_CONFIGURATION_REQUEST = 0,
-        DMG_POWER_SAVE_CONFIGURATION_RESPONSE = 1,
-        DMG_INFORMATION_REQUEST = 2,
-        DMG_INFORMATION_RESPONSE = 3,
-        DMG_HANDOVER_REQUEST = 4,
-        DMG_HANDOVER_RESPONSE = 5,
-        DMG_DTP_REQUEST = 6,
-        DMG_DTP_RESPONSE = 7,
-        DMG_RELAY_SEARCH_REQUEST = 8,
-        DMG_RELAY_SEARCH_RESPONSE = 9,
-        DMG_MULTI_RELAY_CHANNEL_MEASUREMENT_REQUEST = 10,
-        DMG_MULTI_RELAY_CHANNEL_MEASUREMENT_REPORT = 11,
-        DMG_RLS_REQUEST = 12,
-        DMG_RLS_RESPONSE = 13,
-        DMG_RLS_ANNOUNCEMENT = 14,
-        DMG_RLS_TEARDOWN = 15,
-        DMG_RELAY_ACK_REQUEST = 16,
-        DMG_RELAY_ACK_RESPONSE = 17,
-        DMG_TPA_REQUEST = 18,
-        DMG_TPA_RESPONSE = 19,
-        DMG_TPA_REPORT = 20,
-        DMG_ROC_REQUEST = 21,
-        DMG_ROC_RESPONSE = 22
-    };
-
-    /**
-     * FST Action field values
-     * See 802.11ad Table 8-281x
-     */
-    enum FstActionValue
-    {
-        FST_SETUP_REQUEST = 0,
-        FST_SETUP_RESPONSE = 1,
-        FST_TEAR_DOWN = 2,
-        FST_ACK_REQUEST = 3,
-        FST_ACK_RESPONSE = 4,
-        ON_CHANNEL_TUNNEL_REQUEST = 5
-    };
-
-    /**
-     * Unprotected DMG action field values
-     * See 802.11ad Table 8-281ae
-     */
-    enum UnprotectedDmgActionValue
-    {
-        UNPROTECTED_DMG_ANNOUNCE = 0,
-        UNPROTECTED_DMG_BRP = 1,
-        UNPROTECTED_MIMO_BF_SETUP = 2,
-        UNPROTECTED_MIMO_BF_POLL = 3,
-        UNPROTECTED_MIMO_BF_FEEDBACK = 4,
-        UNPROTECTED_MIMO_BF_SELECTION = 5,
-    };
-
-    /**
-     * Protected EHT action field values
-     * See 802.11be D3.0 Table 9-623c
-     */
-    enum ProtectedEhtActionValue
-    {
-        PROTECTED_EHT_TID_TO_LINK_MAPPING_REQUEST = 0,
-        PROTECTED_EHT_TID_TO_LINK_MAPPING_RESPONSE = 1,
-        PROTECTED_EHT_TID_TO_LINK_MAPPING_TEARDOWN = 2,
-        PROTECTED_EHT_EPCS_PRIORITY_ACCESS_ENABLE_REQUEST = 3,
-        PROTECTED_EHT_EPCS_PRIORITY_ACCESS_ENABLE_RESPONSE = 4,
-        PROTECTED_EHT_EPCS_PRIORITY_ACCESS_TEARDOWN = 5,
-        PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION = 6,
-        PROTECTED_EHT_LINK_RECOMMENDATION = 7,
-        PROTECTED_EHT_MULTI_LINK_OPERATION_UPDATE_REQUEST = 8,
-        PROTECTED_EHT_MULTI_LINK_OPERATION_UPDATE_RESPONSE = 9,
-    };
-
-    /**
-     * typedef for union of different ActionValues
-     */
-    typedef union {
-        QosActionValue qos;                                 ///< qos
-        BlockAckActionValue blockAck;                       ///< block ack
-        RadioMeasurementActionValue radioMeasurementAction; ///< radio measurement
-        PublicActionValue publicAction;                     ///< public
-        SelfProtectedActionValue selfProtectedAction;       ///< self protected
-        MultihopActionValue multihopAction;                 ///< multi hop
-        MeshActionValue meshAction;                         ///< mesh
-        DmgActionValue dmgAction;                           ///< dmg
-        FstActionValue fstAction;                           ///< fst
-        UnprotectedDmgActionValue unprotectedDmgAction;     ///< unprotected dmg
-        ProtectedEhtActionValue protectedEhtAction;         ///< protected eht
-    } ActionValue;                                          ///< the action value
-
-    /**
-     * Set action for this Action header.
-     *
-     * \param type category
-     * \param action action
-     */
-    void SetAction(CategoryValue type, ActionValue action);
-
-    /**
-     * Return the category value.
-     *
-     * \return CategoryValue
-     */
-    CategoryValue GetCategory() const;
-    /**
-     * Return the action value.
-     *
-     * \return ActionValue
-     */
-    ActionValue GetAction() const;
-
-    /**
-     * Peek an Action header from the given packet.
-     *
-     * \param pkt the given packet
-     * \return the category value and the action value in the peeked Action header
-     */
-    static std::pair<CategoryValue, ActionValue> Peek(Ptr<const Packet> pkt);
-
-    /**
-     * Remove an Action header from the given packet.
-     *
-     * \param pkt the given packet
-     * \return the category value and the action value in the removed Action header
-     */
-    static std::pair<CategoryValue, ActionValue> Remove(Ptr<Packet> pkt);
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
-
-  private:
-    uint8_t m_category;    //!< Category of the action
-    uint8_t m_actionValue; //!< Action value
-};
-
-/**
- * \ingroup wifi
- * Implement the header for management frames of type Add Block Ack request.
- */
-class MgtAddBaRequestHeader : public Header
-{
-  public:
-    MgtAddBaRequestHeader();
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
-
-    /**
-     * Enable delayed BlockAck.
-     */
-    void SetDelayedBlockAck();
-    /**
-     * Enable immediate BlockAck
-     */
-    void SetImmediateBlockAck();
-    /**
-     * Set Traffic ID (TID).
-     *
-     * \param tid traffic ID
-     */
-    void SetTid(uint8_t tid);
-    /**
-     * Set timeout.
-     *
-     * \param timeout timeout
-     */
-    void SetTimeout(uint16_t timeout);
-    /**
-     * Set buffer size.
-     *
-     * \param size buffer size
-     */
-    void SetBufferSize(uint16_t size);
-    /**
-     * Set the starting sequence number.
-     *
-     * \param seq the starting sequence number
-     */
-    void SetStartingSequence(uint16_t seq);
-    /**
-     * Enable or disable A-MSDU support.
-     *
-     * \param supported enable or disable A-MSDU support
-     */
-    void SetAmsduSupport(bool supported);
-
-    /**
-     * Return the starting sequence number.
-     *
-     * \return the starting sequence number
-     */
-    uint16_t GetStartingSequence() const;
-    /**
-     * Return the Traffic ID (TID).
-     *
-     * \return TID
-     */
-    uint8_t GetTid() const;
-    /**
-     * Return whether the Block Ack policy is immediate Block Ack.
-     *
-     * \return true if immediate Block Ack is being used, false otherwise
-     */
-    bool IsImmediateBlockAck() const;
-    /**
-     * Return the timeout.
-     *
-     * \return timeout
-     */
-    uint16_t GetTimeout() const;
-    /**
-     * Return the buffer size.
-     *
-     * \return the buffer size.
-     */
-    uint16_t GetBufferSize() const;
-    /**
-     * Return whether A-MSDU capability is supported.
-     *
-     * \return true is A-MSDU is supported, false otherwise
-     */
-    bool IsAmsduSupported() const;
-
-  private:
-    /**
-     * Return the raw parameter set.
-     *
-     * \return the raw parameter set
-     */
-    uint16_t GetParameterSet() const;
-    /**
-     * Set the parameter set from the given raw value.
-     *
-     * \param params raw parameter set value
-     */
-    void SetParameterSet(uint16_t params);
-    /**
-     * Return the raw sequence control.
-     *
-     * \return the raw sequence control
-     */
-    uint16_t GetStartingSequenceControl() const;
-    /**
-     * Set sequence control with the given raw value.
-     *
-     * \param seqControl the raw sequence control
-     */
-    void SetStartingSequenceControl(uint16_t seqControl);
-
-    uint8_t m_dialogToken;   //!< Not used for now
-    uint8_t m_amsduSupport;  //!< Flag if A-MSDU is supported
-    uint8_t m_policy;        //!< Block Ack policy
-    uint8_t m_tid;           //!< Traffic ID
-    uint16_t m_bufferSize;   //!< Buffer size
-    uint16_t m_timeoutValue; //!< Timeout
-    uint16_t m_startingSeq;  //!< Starting sequence number
-};
-
-/**
- * \ingroup wifi
- * Implement the header for management frames of type Add Block Ack response.
- */
-class MgtAddBaResponseHeader : public Header
-{
-  public:
-    MgtAddBaResponseHeader();
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
-
-    /**
-     * Enable delayed BlockAck.
-     */
-    void SetDelayedBlockAck();
-    /**
-     * Enable immediate BlockAck.
-     */
-    void SetImmediateBlockAck();
-    /**
-     * Set Traffic ID (TID).
-     *
-     * \param tid traffic ID
-     */
-    void SetTid(uint8_t tid);
-    /**
-     * Set timeout.
-     *
-     * \param timeout timeout
-     */
-    void SetTimeout(uint16_t timeout);
-    /**
-     * Set buffer size.
-     *
-     * \param size buffer size
-     */
-    void SetBufferSize(uint16_t size);
-    /**
-     * Set the status code.
-     *
-     * \param code the status code
-     */
-    void SetStatusCode(StatusCode code);
-    /**
-     * Enable or disable A-MSDU support.
-     *
-     * \param supported enable or disable A-MSDU support
-     */
-    void SetAmsduSupport(bool supported);
-
-    /**
-     * Return the status code.
-     *
-     * \return the status code
-     */
-    StatusCode GetStatusCode() const;
-    /**
-     * Return the Traffic ID (TID).
-     *
-     * \return TID
-     */
-    uint8_t GetTid() const;
-    /**
-     * Return whether the Block Ack policy is immediate Block Ack.
-     *
-     * \return true if immediate Block Ack is being used, false otherwise
-     */
-    bool IsImmediateBlockAck() const;
-    /**
-     * Return the timeout.
-     *
-     * \return timeout
-     */
-    uint16_t GetTimeout() const;
-    /**
-     * Return the buffer size.
-     *
-     * \return the buffer size.
-     */
-    uint16_t GetBufferSize() const;
-    /**
-     * Return whether A-MSDU capability is supported.
-     *
-     * \return true is A-MSDU is supported, false otherwise
-     */
-    bool IsAmsduSupported() const;
-
-  private:
-    /**
-     * Return the raw parameter set.
-     *
-     * \return the raw parameter set
-     */
-    uint16_t GetParameterSet() const;
-    /**
-     * Set the parameter set from the given raw value.
-     *
-     * \param params raw parameter set value
-     */
-    void SetParameterSet(uint16_t params);
-
-    uint8_t m_dialogToken;   //!< Not used for now
-    StatusCode m_code;       //!< Status code
-    uint8_t m_amsduSupport;  //!< Flag if A-MSDU is supported
-    uint8_t m_policy;        //!< Block ACK policy
-    uint8_t m_tid;           //!< Traffic ID
-    uint16_t m_bufferSize;   //!< Buffer size
-    uint16_t m_timeoutValue; //!< Timeout
-};
-
-/**
- * \ingroup wifi
- * Implement the header for management frames of type Delete Block Ack.
- */
-class MgtDelBaHeader : public Header
-{
-  public:
-    MgtDelBaHeader();
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
-
-    /**
-     * Check if the initiator bit in the DELBA is set.
-     *
-     * \return true if the initiator bit in the DELBA is set,
-     *         false otherwise
-     */
-    bool IsByOriginator() const;
-    /**
-     * Return the Traffic ID (TID).
-     *
-     * \return TID
-     */
-    uint8_t GetTid() const;
-    /**
-     * Set Traffic ID (TID).
-     *
-     * \param tid traffic ID
-     */
-    void SetTid(uint8_t tid);
-    /**
-     * Set the initiator bit in the DELBA.
-     */
-    void SetByOriginator();
-    /**
-     * Un-set the initiator bit in the DELBA.
-     */
-    void SetByRecipient();
-
-  private:
-    /**
-     * Return the raw parameter set.
-     *
-     * \return the raw parameter set
-     */
-    uint16_t GetParameterSet() const;
-    /**
-     * Set the parameter set from the given raw value.
-     *
-     * \param params raw parameter set value
-     */
-    void SetParameterSet(uint16_t params);
-
-    uint16_t m_initiator;  //!< initiator
-    uint16_t m_tid;        //!< Traffic ID
-    uint16_t m_reasonCode; //!< Not used for now. Always set to 1: "Unspecified reason"
-};
-
-/**
- * \ingroup wifi
- * Implement the header for Action frames of type EML Operating Mode Notification.
- */
-class MgtEmlOmn : public Header
-{
-  public:
-    MgtEmlOmn() = default;
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
-
-    /**
-     * EML Control field.
-     */
-    struct EmlControl
-    {
-        uint8_t emlsrMode : 1;                  //!< EMLSR Mode
-        uint8_t emlmrMode : 1;                  //!< EMLMR Mode
-        uint8_t emlsrParamUpdateCtrl : 1;       //!< EMLSR Parameter Update Control
-        uint8_t : 5;                            //!< reserved
-        std::optional<uint16_t> linkBitmap;     //!< EMLSR/EMLMR Link Bitmap
-        std::optional<uint8_t> mcsMapCountCtrl; //!< MCS Map Count Control
-        // TODO Add EMLMR Supported MCS And NSS Set subfield when EMLMR is supported
-    };
-
-    /**
-     * EMLSR Parameter Update field.
-     */
-    struct EmlsrParamUpdate
-    {
-        uint8_t paddingDelay : 3;    //!< EMLSR Padding Delay
-        uint8_t transitionDelay : 3; //!< EMLSR Transition Delay
-    };
-
-    /**
-     * Set the bit position in the link bitmap corresponding to the given link.
-     *
-     * \param linkId the ID of the given link
-     */
-    void SetLinkIdInBitmap(uint8_t linkId);
-    /**
-     * \return the ID of the links whose bit position in the link bitmap is set to 1
-     */
-    std::list<uint8_t> GetLinkBitmap() const;
-
-    uint8_t m_dialogToken{0};                             //!< Dialog Token
-    EmlControl m_emlControl{};                            //!< EML Control field
-    std::optional<EmlsrParamUpdate> m_emlsrParamUpdate{}; //!< EMLSR Parameter Update field
-};
-
 } // namespace ns3
 
 #endif /* MGT_HEADERS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/mpdu-aggregator.cc ns-3.41/src/wifi/model/mpdu-aggregator.cc
--- ns-3.40/src/wifi/model/mpdu-aggregator.cc	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/mpdu-aggregator.cc	2024-02-09 14:44:08.589794900 -0800
@@ -33,6 +33,7 @@
 #include "wifi-tx-parameters.h"
 #include "wifi-tx-vector.h"
 
+#include "ns3/eht-capabilities.h"
 #include "ns3/he-capabilities.h"
 #include "ns3/ht-capabilities.h"
 #include "ns3/ht-frame-exchange-manager.h"
@@ -147,14 +148,20 @@
     NS_ASSERT(stationManager);
 
     // Retrieve the Capabilities elements advertised by the recipient
-    Ptr<const HeCapabilities> heCapabilities = stationManager->GetStationHeCapabilities(recipient);
-    Ptr<const VhtCapabilities> vhtCapabilities =
-        stationManager->GetStationVhtCapabilities(recipient);
-    Ptr<const HtCapabilities> htCapabilities = stationManager->GetStationHtCapabilities(recipient);
+    auto ehtCapabilities = stationManager->GetStationEhtCapabilities(recipient);
+    auto heCapabilities = stationManager->GetStationHeCapabilities(recipient);
+    auto vhtCapabilities = stationManager->GetStationVhtCapabilities(recipient);
+    auto htCapabilities = stationManager->GetStationHtCapabilities(recipient);
 
     // Determine the constraint imposed by the recipient based on the PPDU
     // format used to transmit the A-MPDU
-    if (modulation >= WIFI_MOD_CLASS_HE)
+    if (modulation >= WIFI_MOD_CLASS_EHT)
+    {
+        NS_ABORT_MSG_IF(!ehtCapabilities, "EHT Capabilities element not received");
+
+        maxAmpduSize = std::min(maxAmpduSize, ehtCapabilities->GetMaxAmpduLength());
+    }
+    else if (modulation >= WIFI_MOD_CLASS_HE)
     {
         NS_ABORT_MSG_IF(!heCapabilities, "HE Capabilities element not received");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/msdu-aggregator.cc ns-3.41/src/wifi/model/msdu-aggregator.cc
--- ns-3.40/src/wifi/model/msdu-aggregator.cc	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/msdu-aggregator.cc	2024-02-09 14:44:08.589794900 -0800
@@ -127,11 +127,16 @@
     uint8_t nMsdu = 1;
     peekedItem = queue->PeekByTidAndAddress(tid, recipient, peekedItem->GetOriginal());
 
-    while (peekedItem &&
+    // stop aggregation if we find an A-MSDU in the queue. This likely happens when an A-MSDU is
+    // prepared but not transmitted due to RTS/CTS failure
+    while (peekedItem && !peekedItem->GetHeader().IsQosAmsdu() &&
            m_htFem->TryAggregateMsdu(peekedItem = m_htFem->CreateAliasIfNeeded(peekedItem),
                                      txParams,
                                      availableTime))
     {
+        NS_ASSERT_MSG(!peekedItem->HasSeqNoAssigned(),
+                      "Found item with sequence number assignment after one without: perhaps "
+                      "sequence numbers were not released correctly?");
         // find the next MPDU before dequeuing the current one
         Ptr<const WifiMpdu> msdu = peekedItem->GetOriginal();
         peekedItem = queue->PeekByTidAndAddress(tid, recipient, msdu);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/non-ht/dsss-phy.cc ns-3.41/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.40/src/wifi/model/non-ht/dsss-phy.cc	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/non-ht/dsss-phy.cc	2024-02-09 14:44:08.589794900 -0800
@@ -74,7 +74,7 @@
 GetDsssRatesBpsList()
 {
     return s_dsssRatesBpsList;
-};
+}
 
 DsssPhy::DsssPhy()
 {
@@ -311,7 +311,7 @@
     {                                                                                              \
         static WifiMode mode = CreateDsssMode(#x, WIFI_MOD_CLASS_##m);                             \
         return mode;                                                                               \
-    };
+    }
 
 // Clause 15 rates (DSSS)
 GET_DSSS_MODE(DsssRate1Mbps, DSSS)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.41/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.40/src/wifi/model/non-ht/erp-ofdm-phy.cc	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/non-ht/erp-ofdm-phy.cc	2024-02-09 14:44:08.589794900 -0800
@@ -69,7 +69,7 @@
 GetErpOfdmRatesBpsList()
 {
     return s_erpOfdmRatesBpsList;
-};
+}
 
 ErpOfdmPhy::ErpOfdmPhy()
     : OfdmPhy(OFDM_PHY_DEFAULT, false) // don't add OFDM modes to list
@@ -162,7 +162,7 @@
     {                                                                                              \
         static WifiMode mode = CreateErpOfdmMode(#x, f);                                           \
         return mode;                                                                               \
-    };
+    }
 
 GET_ERP_OFDM_MODE(ErpOfdmRate6Mbps, true)
 GET_ERP_OFDM_MODE(ErpOfdmRate9Mbps, false)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/non-ht/ofdm-phy.cc ns-3.41/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.40/src/wifi/model/non-ht/ofdm-phy.cc	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/non-ht/ofdm-phy.cc	2024-02-09 14:44:08.589794900 -0800
@@ -101,7 +101,7 @@
 GetOfdmRatesBpsList()
 {
     return s_ofdmRatesBpsList;
-};
+}
 
 OfdmPhy::OfdmPhy(OfdmPhyVariant variant /* = OFDM_PHY_DEFAULT */, bool buildModeList /* = true */)
 {
@@ -495,7 +495,7 @@
     {                                                                                              \
         static WifiMode mode = CreateOfdmMode(#x, f);                                              \
         return mode;                                                                               \
-    };
+    }
 
 // 20 MHz channel rates (default)
 GET_OFDM_MODE(OfdmRate6Mbps, true)
@@ -690,7 +690,7 @@
     const auto txWidth = ppdu->GetTxChannelWidth();
     const auto& txVector = ppdu->GetTxVector();
     // Update channel width in TXVECTOR for non-HT duplicate PPDUs.
-    if ((txVector.IsNonHtDuplicate() && (txWidth > m_wifiPhy->GetChannelWidth())))
+    if (txVector.IsNonHtDuplicate() && txWidth > m_wifiPhy->GetChannelWidth())
     {
         // We also do a copy of the PPDU for non-HT duplicate PPDUs since other
         // PHYs might set a different channel width in the reconstructed TXVECTOR.
